from typing import List
import docking.widgets.tree
import docking.widgets.tree.support
import ghidra.app.plugin.core.debug.gui.tracermi.connection.tree
import ghidra.debug.api.target
import ghidra.debug.api.tracemgr
import ghidra.debug.api.tracermi
import ghidra.util.task
import java.lang
import java.net
import java.util
import java.util.function
import java.util.stream
import javax.swing
import javax.swing.tree


class TraceRmiServiceNode(ghidra.app.plugin.core.debug.gui.tracermi.connection.tree.AbstractTraceRmiManagerNode, ghidra.debug.api.tracermi.TraceRmiServiceListener, ghidra.debug.api.target.TargetPublicationListener):




    def __init__(self, __a0: ghidra.app.plugin.core.debug.gui.tracermi.connection.TraceRmiConnectionManagerProvider): ...



    def acceptCancelled(self, __a0: ghidra.debug.api.tracermi.TraceRmiAcceptor) -> None: ...

    def acceptFailed(self, __a0: ghidra.debug.api.tracermi.TraceRmiAcceptor, __a1: java.lang.Exception) -> None: ...

    @overload
    def addNode(self, __a0: docking.widgets.tree.GTreeNode) -> None: ...

    @overload
    def addNode(self, __a0: int, __a1: docking.widgets.tree.GTreeNode) -> None: ...

    def addNodes(self, __a0: List[object]) -> None: ...

    def clone(self) -> object: ...

    def collapse(self) -> None: ...

    @overload
    def compareTo(self, __a0: docking.widgets.tree.GTreeNode) -> int: ...

    @overload
    def compareTo(self, __a0: object) -> int: ...

    def connected(self, __a0: ghidra.debug.api.tracermi.TraceRmiConnection, __a1: ghidra.debug.api.tracermi.TraceRmiServiceListener.ConnectMode, __a2: ghidra.debug.api.tracermi.TraceRmiAcceptor) -> None: ...

    def coordinates(self, __a0: ghidra.debug.api.tracemgr.DebuggerCoordinates) -> None: ...

    def disconnected(self, __a0: ghidra.debug.api.tracermi.TraceRmiConnection) -> None: ...

    def dispose(self) -> None: ...

    def equals(self, __a0: object) -> bool: ...

    def expand(self) -> None: ...

    def filter(self, __a0: docking.widgets.tree.support.GTreeFilter, __a1: ghidra.util.task.TaskMonitor) -> docking.widgets.tree.GTreeNode: ...

    def fireNodeChanged(self) -> None: ...

    def fireNodeStructureChanged(self) -> None: ...

    @overload
    def getChild(self, __a0: int) -> docking.widgets.tree.GTreeNode: ...

    @overload
    def getChild(self, __a0: unicode) -> docking.widgets.tree.GTreeNode: ...

    @overload
    def getChild(self, __a0: unicode, __a1: java.util.function.Predicate) -> docking.widgets.tree.GTreeNode: ...

    def getChildCount(self) -> int: ...

    def getChildren(self) -> List[object]: ...

    def getClass(self) -> java.lang.Class: ...

    def getDisplayText(self) -> unicode: ...

    def getIcon(self, __a0: bool) -> javax.swing.Icon: ...

    def getIndexInParent(self) -> int: ...

    def getIndexOfChild(self, __a0: docking.widgets.tree.GTreeNode) -> int: ...

    def getLeafCount(self) -> int: ...

    def getName(self) -> unicode: ...

    def getNodeCount(self) -> int: ...

    def getParent(self) -> docking.widgets.tree.GTreeNode: ...

    def getRoot(self) -> docking.widgets.tree.GTreeNode: ...

    def getToolTip(self) -> unicode: ...

    def getTree(self) -> docking.widgets.tree.GTree: ...

    def getTreePath(self) -> javax.swing.tree.TreePath: ...

    def hashCode(self) -> int: ...

    def isAncestor(self, __a0: docking.widgets.tree.GTreeNode) -> bool: ...

    def isAutoExpandPermitted(self) -> bool: ...

    def isEditable(self) -> bool: ...

    def isExpanded(self) -> bool: ...

    def isInProgress(self) -> bool: ...

    def isLeaf(self) -> bool: ...

    def isLoaded(self) -> bool: ...

    def isRoot(self) -> bool: ...

    def iterator(self, __a0: bool) -> java.util.Iterator: ...

    def loadAll(self, __a0: ghidra.util.task.TaskMonitor) -> int: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def removeAll(self) -> None: ...

    def removeNode(self, __a0: docking.widgets.tree.GTreeNode) -> None: ...

    def serverStarted(self, __a0: java.net.SocketAddress) -> None: ...

    def serverStopped(self) -> None: ...

    def setChildren(self, __a0: List[object]) -> None: ...

    def stream(self, __a0: bool) -> java.util.stream.Stream: ...

    @overload
    def targetPublished(self, __a0: ghidra.debug.api.target.Target) -> None: ...

    @overload
    def targetPublished(self, __a0: ghidra.debug.api.tracermi.TraceRmiConnection, __a1: ghidra.debug.api.target.Target) -> None: ...

    def targetWithdrawn(self, __a0: ghidra.debug.api.target.Target) -> None: ...

    def toString(self) -> unicode: ...

    def valueChanged(self, __a0: object) -> None: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    def waitingAccept(self, __a0: ghidra.debug.api.tracermi.TraceRmiAcceptor) -> None: ...

    @property
    def leaf(self) -> bool: ...

    @property
    def toolTip(self) -> unicode: ...