from typing import List
import ghidra.app.util.bin
import ghidra.app.util.bin.format.omf
import ghidra.app.util.bin.format.omf.OmfFixupRecord
import java.lang


class OmfFixupRecord(ghidra.app.util.bin.format.omf.OmfRecord):





    class Subrecord(object):




        def __init__(self): ...



        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def getDataRecordOffset(self) -> int: ...

        def getFixMethod(self) -> int: ...

        def getFixMethodWithSub(self, __a0: ghidra.app.util.bin.format.omf.OmfFixupRecord.Subrecord) -> int: ...

        def getFixThreadNum(self) -> int: ...

        def getFrameMethod(self) -> int: ...

        def getIndex(self) -> int: ...

        def getLocationType(self) -> int: ...

        def getTargetDatum(self) -> int: ...

        def getTargetDisplacement(self) -> int: ...

        def getThreadMethod(self) -> int: ...

        def getThreadNum(self) -> int: ...

        def hashCode(self) -> int: ...

        def isFrameInSubThread(self) -> bool: ...

        def isFrameThread(self) -> bool: ...

        def isSegmentRelative(self) -> bool: ...

        def isTargetThread(self) -> bool: ...

        def isThreadSubrecord(self) -> bool: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        @staticmethod
        def readSubrecord(__a0: ghidra.app.util.bin.BinaryReader, __a1: bool) -> ghidra.app.util.bin.format.omf.OmfFixupRecord.Subrecord: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...

        @property
        def dataRecordOffset(self) -> int: ...

        @property
        def fixMethod(self) -> int: ...

        @property
        def fixThreadNum(self) -> int: ...

        @property
        def frameInSubThread(self) -> bool: ...

        @property
        def frameMethod(self) -> int: ...

        @property
        def frameThread(self) -> bool: ...

        @property
        def index(self) -> int: ...

        @property
        def locationType(self) -> int: ...

        @property
        def segmentRelative(self) -> bool: ...

        @property
        def targetDatum(self) -> int: ...

        @property
        def targetDisplacement(self) -> int: ...

        @property
        def targetThread(self) -> bool: ...

        @property
        def threadMethod(self) -> int: ...

        @property
        def threadNum(self) -> int: ...

        @property
        def threadSubrecord(self) -> bool: ...

    def __init__(self, reader: ghidra.app.util.bin.BinaryReader):
        """
        Read a Fixup record from the input reader
        @param reader The actual reader
        @throws IOException
        """
        ...



    def calcCheckSum(self, reader: ghidra.app.util.bin.BinaryReader) -> int: ...

    def equals(self, __a0: object) -> bool: ...

    def getClass(self) -> java.lang.Class: ...

    def getDataBlock(self) -> ghidra.app.util.bin.format.omf.OmfData:
        """
        @return The datablock this fixup record is meant for
        """
        ...

    def getRecordLength(self) -> int: ...

    @staticmethod
    def getRecordName(type: int) -> unicode:
        """
        Gets the name of the given record type
        @param type The record type
        @return The name of the given record type
        """
        ...

    def getRecordOffset(self) -> long: ...

    def getRecordType(self) -> int: ...

    def getSubrecords(self) -> List[ghidra.app.util.bin.format.omf.OmfFixupRecord.Subrecord]:
        """
        @return The array of subrecords
        """
        ...

    def hasBigFields(self) -> bool: ...

    def hashCode(self) -> int: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def readCheckSumByte(self, reader: ghidra.app.util.bin.BinaryReader) -> None: ...

    @staticmethod
    def readIndex(reader: ghidra.app.util.bin.BinaryReader) -> int: ...

    @staticmethod
    def readInt1Or2(reader: ghidra.app.util.bin.BinaryReader, isBig: bool) -> int: ...

    @staticmethod
    def readInt2Or4(reader: ghidra.app.util.bin.BinaryReader, isBig: bool) -> int: ...

    @staticmethod
    def readRecord(reader: ghidra.app.util.bin.BinaryReader) -> ghidra.app.util.bin.format.omf.OmfRecord: ...

    def readRecordHeader(self, reader: ghidra.app.util.bin.BinaryReader) -> None: ...

    @staticmethod
    def readString(reader: ghidra.app.util.bin.BinaryReader) -> unicode:
        """
        Read the OMF string format: 1-byte length, followed by that many ascii characters
        @param reader A {@link BinaryReader} positioned at the start of the string
        @return the read OMF string
        @throws IOException if an IO-related error occurred
        """
        ...

    def setDataBlock(self, last: ghidra.app.util.bin.format.omf.OmfData) -> None:
        """
        @param last The Datablock this fixup record is meant for
        """
        ...

    def toString(self) -> unicode: ...

    def validCheckSum(self, reader: ghidra.app.util.bin.BinaryReader) -> bool: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def dataBlock(self) -> ghidra.app.util.bin.format.omf.OmfData: ...

    @dataBlock.setter
    def dataBlock(self, value: ghidra.app.util.bin.format.omf.OmfData) -> None: ...

    @property
    def subrecords(self) -> List[ghidra.app.util.bin.format.omf.OmfFixupRecord.Subrecord]: ...