from typing import List
import docking.widgets.fieldpanel.field
import ghidra.app.nav
import ghidra.app.util.viewer.field
import ghidra.framework.plugintool
import ghidra.program.model.address
import ghidra.program.model.listing
import java.lang


class AddressAnnotatedStringHandler(object, ghidra.app.util.viewer.field.AnnotatedStringHandler):
    """
    An annotated string handler that allows handles annotations that begin with
     #SUPPORTED_ANNOTATIONS.  This class expects one string following the annotation
     text that is an address string and will display that string as its display text.
    """

    DUMMY_MOUSE_HANDLER: ghidra.app.util.viewer.field.AnnotatedMouseHandler = ghidra.app.util.viewer.field.AnnotatedStringHandler$1@20eafa3c



    def __init__(self): ...



    @overload
    @staticmethod
    def createAddressAnnotationString(addressOffset: long, displayText: unicode) -> unicode:
        """
        Constructs a well-formed Address Annotation comment string.
        @param addressOffset destination of the annotation
        @param displayText text that will be used as the body of the annotation.  Problematic
         characters will be escaped
        @return string
        """
        ...

    @overload
    @staticmethod
    def createAddressAnnotationString(destinationAddress: ghidra.program.model.address.Address, displayText: unicode) -> unicode:
        """
        Constructs a well-formed Address Annotation comment string.
        @param destinationAddress destination of the annotation
        @param displayText text that will be used as the body of the annotation.  Problematic
         characters will be escaped
        @return string
        """
        ...

    def createAnnotatedString(self, prototypeString: docking.widgets.fieldpanel.field.AttributedString, text: List[unicode], program: ghidra.program.model.listing.Program) -> docking.widgets.fieldpanel.field.AttributedString: ...

    def equals(self, __a0: object) -> bool: ...

    @staticmethod
    def escapeAnnotationPart(__a0: unicode) -> unicode: ...

    def getClass(self) -> java.lang.Class: ...

    def getDisplayString(self) -> unicode: ...

    @overload
    def getPrototypeString(self) -> unicode: ...

    @overload
    def getPrototypeString(self, displayText: unicode) -> unicode: ...

    def getSupportedAnnotations(self) -> List[unicode]: ...

    def handleMouseClick(self, annotationParts: List[unicode], sourceNavigatable: ghidra.app.nav.Navigatable, serviceProvider: ghidra.framework.plugintool.ServiceProvider) -> bool: ...

    def hashCode(self) -> int: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def displayString(self) -> unicode: ...

    @property
    def prototypeString(self) -> unicode: ...

    @property
    def supportedAnnotations(self) -> List[unicode]: ...