import ghidra.dbg.target
import ghidra.debug.api.target
import ghidra.debug.api.tracemgr
import ghidra.framework.options
import ghidra.framework.plugintool
import ghidra.trace.model
import ghidra.trace.model.guest
import ghidra.trace.model.program
import ghidra.trace.model.target
import ghidra.trace.model.thread
import ghidra.trace.model.time.schedule
import java.lang


class DebuggerCoordinates(object):
    NOWHERE: ghidra.debug.api.tracemgr.DebuggerCoordinates = Coords(trace=null,target=null,thread=null,view=null,time=null,frame=null,path=null)







    def equals(self, __a0: object) -> bool: ...

    @staticmethod
    def equalsIgnoreRecorderAndView(__a0: ghidra.debug.api.tracemgr.DebuggerCoordinates, __a1: ghidra.debug.api.tracemgr.DebuggerCoordinates) -> bool: ...

    @overload
    def frame(self, __a0: int) -> ghidra.debug.api.tracemgr.DebuggerCoordinates: ...

    @overload
    def frame(self, __a0: int) -> ghidra.debug.api.tracemgr.DebuggerCoordinates: ...

    def getClass(self) -> java.lang.Class: ...

    def getFrame(self) -> int: ...

    def getObject(self) -> ghidra.trace.model.target.TraceObject: ...

    def getPath(self) -> ghidra.trace.model.target.TraceObjectKeyPath: ...

    def getPlatform(self) -> ghidra.trace.model.guest.TracePlatform: ...

    def getRegisterContainer(self) -> ghidra.trace.model.target.TraceObject: ...

    def getSnap(self) -> long: ...

    def getTarget(self) -> ghidra.debug.api.target.Target: ...

    def getThread(self) -> ghidra.trace.model.thread.TraceThread: ...

    def getTime(self) -> ghidra.trace.model.time.schedule.TraceSchedule: ...

    def getTrace(self) -> ghidra.trace.model.Trace: ...

    def getView(self) -> ghidra.trace.model.program.TraceProgramView: ...

    def getViewSnap(self) -> long: ...

    def hashCode(self) -> int: ...

    def isAlive(self) -> bool: ...

    def isAliveAndPresent(self) -> bool: ...

    def isAliveAndReadsPresent(self) -> bool: ...

    def isDeadOrPresent(self) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    @overload
    def object(self, __a0: ghidra.dbg.target.TargetObject) -> ghidra.debug.api.tracemgr.DebuggerCoordinates: ...

    @overload
    def object(self, __a0: ghidra.trace.model.target.TraceObject) -> ghidra.debug.api.tracemgr.DebuggerCoordinates: ...

    def path(self, __a0: ghidra.trace.model.target.TraceObjectKeyPath) -> ghidra.debug.api.tracemgr.DebuggerCoordinates: ...

    def platform(self, __a0: ghidra.trace.model.guest.TracePlatform) -> ghidra.debug.api.tracemgr.DebuggerCoordinates: ...

    def reFindThread(self) -> ghidra.debug.api.tracemgr.DebuggerCoordinates: ...

    @staticmethod
    def readDataState(__a0: ghidra.framework.plugintool.PluginTool, __a1: ghidra.framework.options.SaveState, __a2: unicode) -> ghidra.debug.api.tracemgr.DebuggerCoordinates: ...

    def snap(self, __a0: long) -> ghidra.debug.api.tracemgr.DebuggerCoordinates: ...

    def snapNoResolve(self, __a0: long) -> ghidra.debug.api.tracemgr.DebuggerCoordinates: ...

    def target(self, __a0: ghidra.debug.api.target.Target) -> ghidra.debug.api.tracemgr.DebuggerCoordinates: ...

    def thread(self, __a0: ghidra.trace.model.thread.TraceThread) -> ghidra.debug.api.tracemgr.DebuggerCoordinates: ...

    def time(self, __a0: ghidra.trace.model.time.schedule.TraceSchedule) -> ghidra.debug.api.tracemgr.DebuggerCoordinates: ...

    def toString(self) -> unicode: ...

    def trace(self, __a0: ghidra.trace.model.Trace) -> ghidra.debug.api.tracemgr.DebuggerCoordinates: ...

    def view(self, __a0: ghidra.trace.model.program.TraceProgramView) -> ghidra.debug.api.tracemgr.DebuggerCoordinates: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    def writeDataState(self, __a0: ghidra.framework.plugintool.PluginTool, __a1: ghidra.framework.options.SaveState, __a2: unicode) -> None: ...

    @property
    def alive(self) -> bool: ...

    @property
    def aliveAndPresent(self) -> bool: ...

    @property
    def aliveAndReadsPresent(self) -> bool: ...

    @property
    def deadOrPresent(self) -> bool: ...

    @property
    def registerContainer(self) -> ghidra.trace.model.target.TraceObject: ...

    @property
    def viewSnap(self) -> long: ...