import ghidra.app.util.bin
import ghidra.program.model.data
import java.lang


class CramFsInode(object, ghidra.app.util.bin.StructConverter):
    ASCII: ghidra.program.model.data.DataType = char
    BYTE: ghidra.program.model.data.DataType = byte
    DWORD: ghidra.program.model.data.DataType = dword
    IBO32: ghidra.program.model.data.DataType = IBO32DataType: typedef ImageBaseOffset32 pointer32
    IBO64: ghidra.program.model.data.DataType = IBO64DataType: typedef ImageBaseOffset64 pointer64
    POINTER: ghidra.program.model.data.DataType = pointer
    QWORD: ghidra.program.model.data.DataType = qword
    SLEB128: ghidra.program.model.data.SignedLeb128DataType = sleb128
    STRING: ghidra.program.model.data.DataType = string
    ULEB128: ghidra.program.model.data.UnsignedLeb128DataType = uleb128
    UTF16: ghidra.program.model.data.DataType = unicode
    UTF8: ghidra.program.model.data.DataType = string-utf8
    VOID: ghidra.program.model.data.DataType = void
    WORD: ghidra.program.model.data.DataType = word



    def __init__(self, __a0: ghidra.app.util.bin.BinaryReader): ...



    def equals(self, __a0: object) -> bool: ...

    def getAddress(self) -> long: ...

    def getClass(self) -> java.lang.Class: ...

    def getGid(self) -> int: ...

    def getMode(self) -> int: ...

    def getName(self) -> unicode: ...

    def getNamelen(self) -> int: ...

    def getOffset(self) -> int: ...

    def getOffsetAdjusted(self) -> int: ...

    def getSize(self) -> int: ...

    def getUid(self) -> int: ...

    def hashCode(self) -> int: ...

    def isDirectory(self) -> bool: ...

    def isFile(self) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def toDataType(self) -> ghidra.program.model.data.DataType: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def address(self) -> long: ...

    @property
    def directory(self) -> bool: ...

    @property
    def file(self) -> bool: ...

    @property
    def gid(self) -> int: ...

    @property
    def mode(self) -> int: ...

    @property
    def name(self) -> unicode: ...

    @property
    def namelen(self) -> int: ...

    @property
    def offset(self) -> int: ...

    @property
    def offsetAdjusted(self) -> int: ...

    @property
    def size(self) -> int: ...

    @property
    def uid(self) -> int: ...