from typing import List
import ghidra.framework.data
import ghidra.framework.model
import ghidra.util.task
import java.io
import java.lang
import java.net


class GhidraFolder(object, ghidra.framework.model.DomainFolder):
    CLOSED_FOLDER_ICON: javax.swing.Icon = jar:file:/opt/hostedtoolcache/ghidra/11.0.3/x64/Ghidra/Framework/Gui/lib/Gui.jar!/images/core.png
    COPY_SUFFIX: unicode = u'.copy'
    OPEN_FOLDER_ICON: javax.swing.Icon = jar:file:/opt/hostedtoolcache/ghidra/11.0.3/x64/Ghidra/Framework/Gui/lib/Gui.jar!/images/core.png
    SEPARATOR: unicode = u'/'







    @overload
    def compareTo(self, df: ghidra.framework.model.DomainFolder) -> int: ...

    @overload
    def compareTo(self, __a0: object) -> int: ...

    def copyTo(self, newParent: ghidra.framework.model.DomainFolder, monitor: ghidra.util.task.TaskMonitor) -> ghidra.framework.data.GhidraFolder: ...

    def copyToAsLink(self, newParent: ghidra.framework.model.DomainFolder) -> ghidra.framework.model.DomainFile: ...

    @overload
    def createFile(self, fileName: unicode, obj: ghidra.framework.model.DomainObject, monitor: ghidra.util.task.TaskMonitor) -> ghidra.framework.model.DomainFile: ...

    @overload
    def createFile(self, fileName: unicode, packFile: java.io.File, monitor: ghidra.util.task.TaskMonitor) -> ghidra.framework.model.DomainFile: ...

    def createFolder(self, folderName: unicode) -> ghidra.framework.data.GhidraFolder: ...

    def delete(self) -> None: ...

    def equals(self, obj: object) -> bool: ...

    def getClass(self) -> java.lang.Class: ...

    def getFile(self, fileName: unicode) -> ghidra.framework.data.GhidraFile: ...

    def getFiles(self) -> List[ghidra.framework.data.GhidraFile]: ...

    def getFolder(self, folderName: unicode) -> ghidra.framework.data.GhidraFolder: ...

    def getFolders(self) -> List[ghidra.framework.data.GhidraFolder]: ...

    def getLocalProjectURL(self) -> java.net.URL: ...

    def getName(self) -> unicode: ...

    def getParent(self) -> ghidra.framework.model.DomainFolder: ...

    def getPathname(self) -> unicode: ...

    def getProjectData(self) -> ghidra.framework.data.DefaultProjectData: ...

    def getProjectLocator(self) -> ghidra.framework.model.ProjectLocator: ...

    def getSharedProjectURL(self) -> java.net.URL: ...

    def hashCode(self) -> int: ...

    def isEmpty(self) -> bool: ...

    def isInWritableProject(self) -> bool: ...

    def isLinked(self) -> bool: ...

    def moveTo(self, newParent: ghidra.framework.model.DomainFolder) -> ghidra.framework.data.GhidraFolder: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def setActive(self) -> None: ...

    def setName(self, newName: unicode) -> ghidra.framework.data.GhidraFolder: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def empty(self) -> bool: ...

    @property
    def files(self) -> List[ghidra.framework.data.GhidraFile]: ...

    @property
    def folders(self) -> List[ghidra.framework.data.GhidraFolder]: ...

    @property
    def inWritableProject(self) -> bool: ...

    @property
    def linked(self) -> bool: ...

    @property
    def localProjectURL(self) -> java.net.URL: ...

    @property
    def name(self) -> unicode: ...

    @name.setter
    def name(self, value: unicode) -> None: ...

    @property
    def parent(self) -> ghidra.framework.model.DomainFolder: ...

    @property
    def pathname(self) -> unicode: ...

    @property
    def projectData(self) -> ghidra.framework.data.DefaultProjectData: ...

    @property
    def projectLocator(self) -> ghidra.framework.model.ProjectLocator: ...

    @property
    def sharedProjectURL(self) -> java.net.URL: ...