from typing import List
import ghidra.framework.data
import ghidra.framework.model
import ghidra.framework.store
import ghidra.util.task
import java.io
import java.lang
import java.net
import java.util
import javax.swing


class LinkedDomainFile(ghidra.framework.model.DomainFile, object):
    """
     corresponds to a DomainFile contained within a
     LinkedDomainFolder.
    """

    DEFAULT_VERSION: int = -1
    READ_ONLY_PROPERTY: unicode = u'READ_ONLY'
    UNSUPPORTED_FILE_ICON: javax.swing.Icon = jar:file:/opt/hostedtoolcache/ghidra/11.0.3/x64/Ghidra/Framework/Gui/lib/Gui.jar!/images/core.png







    def addToVersionControl(self, __a0: unicode, __a1: bool, __a2: ghidra.util.task.TaskMonitor) -> None: ...

    def canAddToRepository(self) -> bool: ...

    def canCheckin(self) -> bool: ...

    def canCheckout(self) -> bool: ...

    def canMerge(self) -> bool: ...

    def canRecover(self) -> bool: ...

    def canSave(self) -> bool: ...

    def checkin(self, __a0: ghidra.framework.data.CheckinHandler, __a1: bool, __a2: ghidra.util.task.TaskMonitor) -> None: ...

    def checkout(self, __a0: bool, __a1: ghidra.util.task.TaskMonitor) -> bool: ...

    def compareTo(self, __a0: object) -> int: ...

    def copyTo(self, __a0: ghidra.framework.model.DomainFolder, __a1: ghidra.util.task.TaskMonitor) -> ghidra.framework.model.DomainFile: ...

    def copyToAsLink(self, __a0: ghidra.framework.model.DomainFolder) -> ghidra.framework.model.DomainFile: ...

    def copyVersionTo(self, __a0: int, __a1: ghidra.framework.model.DomainFolder, __a2: ghidra.util.task.TaskMonitor) -> ghidra.framework.model.DomainFile: ...

    @overload
    def delete(self) -> None: ...

    @overload
    def delete(self, __a0: int) -> None: ...

    def equals(self, __a0: object) -> bool: ...

    def exists(self) -> bool: ...

    def followLink(self) -> ghidra.framework.model.DomainFolder: ...

    def getChangesByOthersSinceCheckout(self) -> ghidra.framework.model.ChangeSet: ...

    def getCheckoutStatus(self) -> ghidra.framework.store.ItemCheckoutStatus: ...

    def getCheckouts(self) -> List[ghidra.framework.store.ItemCheckoutStatus]: ...

    def getClass(self) -> java.lang.Class: ...

    def getConsumers(self) -> List[object]: ...

    def getContentType(self) -> unicode: ...

    def getDomainObject(self, __a0: object, __a1: bool, __a2: bool, __a3: ghidra.util.task.TaskMonitor) -> ghidra.framework.model.DomainObject: ...

    def getDomainObjectClass(self) -> java.lang.Class: ...

    def getFileID(self) -> unicode: ...

    def getIcon(self, __a0: bool) -> javax.swing.Icon: ...

    def getImmutableDomainObject(self, __a0: object, __a1: int, __a2: ghidra.util.task.TaskMonitor) -> ghidra.framework.model.DomainObject: ...

    def getLastModifiedTime(self) -> long: ...

    def getLatestVersion(self) -> int: ...

    def getLinkedFile(self) -> ghidra.framework.model.DomainFile:
        """
        Get the real domain file which corresponds to this file contained within a linked-folder.
        @return domain file
        @throws IOException if IO error occurs or file not found
        """
        ...

    def getLocalProjectURL(self, __a0: unicode) -> java.net.URL: ...

    def getMetadata(self) -> java.util.Map: ...

    def getName(self) -> unicode: ...

    def getOpenedDomainObject(self, __a0: object) -> ghidra.framework.model.DomainObject: ...

    def getParent(self) -> ghidra.framework.model.DomainFolder: ...

    def getPathname(self) -> unicode: ...

    def getProjectLocator(self) -> ghidra.framework.model.ProjectLocator: ...

    def getReadOnlyDomainObject(self, __a0: object, __a1: int, __a2: ghidra.util.task.TaskMonitor) -> ghidra.framework.model.DomainObject: ...

    def getSharedProjectURL(self, __a0: unicode) -> java.net.URL: ...

    def getVersion(self) -> int: ...

    def getVersionHistory(self) -> List[ghidra.framework.store.Version]: ...

    def hashCode(self) -> int: ...

    def isBusy(self) -> bool: ...

    def isChanged(self) -> bool: ...

    def isCheckedOut(self) -> bool: ...

    def isCheckedOutExclusive(self) -> bool: ...

    def isHijacked(self) -> bool: ...

    def isInWritableProject(self) -> bool: ...

    def isLatestVersion(self) -> bool: ...

    def isLinkFile(self) -> bool: ...

    def isLinkingSupported(self) -> bool: ...

    def isOpen(self) -> bool: ...

    def isReadOnly(self) -> bool: ...

    def isVersioned(self) -> bool: ...

    def length(self) -> long: ...

    def merge(self, __a0: bool, __a1: ghidra.util.task.TaskMonitor) -> None: ...

    def modifiedSinceCheckout(self) -> bool: ...

    def moveTo(self, __a0: ghidra.framework.model.DomainFolder) -> ghidra.framework.model.DomainFile: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def packFile(self, __a0: java.io.File, __a1: ghidra.util.task.TaskMonitor) -> None: ...

    def save(self, __a0: ghidra.util.task.TaskMonitor) -> None: ...

    def setName(self, __a0: unicode) -> ghidra.framework.model.DomainFile: ...

    def setReadOnly(self, __a0: bool) -> None: ...

    def takeRecoverySnapshot(self) -> bool: ...

    def terminateCheckout(self, __a0: long) -> None: ...

    def toString(self) -> unicode: ...

    @overload
    def undoCheckout(self, __a0: bool) -> None: ...

    @overload
    def undoCheckout(self, __a0: bool, __a1: bool) -> None: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def busy(self) -> bool: ...

    @property
    def changed(self) -> bool: ...

    @property
    def changesByOthersSinceCheckout(self) -> ghidra.framework.model.ChangeSet: ...

    @property
    def checkedOut(self) -> bool: ...

    @property
    def checkedOutExclusive(self) -> bool: ...

    @property
    def checkoutStatus(self) -> ghidra.framework.store.ItemCheckoutStatus: ...

    @property
    def checkouts(self) -> List[ghidra.framework.store.ItemCheckoutStatus]: ...

    @property
    def consumers(self) -> List[object]: ...

    @property
    def contentType(self) -> unicode: ...

    @property
    def domainObjectClass(self) -> java.lang.Class: ...

    @property
    def fileID(self) -> unicode: ...

    @property
    def hijacked(self) -> bool: ...

    @property
    def inWritableProject(self) -> bool: ...

    @property
    def lastModifiedTime(self) -> long: ...

    @property
    def latestVersion(self) -> bool: ...

    @property
    def linkFile(self) -> bool: ...

    @property
    def linkedFile(self) -> ghidra.framework.model.DomainFile: ...

    @property
    def linkingSupported(self) -> bool: ...

    @property
    def metadata(self) -> java.util.Map: ...

    @property
    def name(self) -> unicode: ...

    @name.setter
    def name(self, value: unicode) -> None: ...

    @property
    def open(self) -> bool: ...

    @property
    def parent(self) -> ghidra.framework.model.DomainFolder: ...

    @property
    def pathname(self) -> unicode: ...

    @property
    def projectLocator(self) -> ghidra.framework.model.ProjectLocator: ...

    @property
    def readOnly(self) -> bool: ...

    @readOnly.setter
    def readOnly(self, value: bool) -> None: ...

    @property
    def version(self) -> int: ...

    @property
    def versionHistory(self) -> List[ghidra.framework.store.Version]: ...

    @property
    def versioned(self) -> bool: ...