import ghidra.app.plugin.processors.sleigh
import ghidra.pcode.emu
import ghidra.pcode.emu.PcodeMachine
import ghidra.pcode.exec
import ghidra.program.model.address
import java.lang
import java.util


class AuxPcodeEmulator(ghidra.pcode.emu.AbstractPcodeMachine):
    """
    A stand-alone emulator whose parts are manufactured by a AuxEmulatorPartsFactory
 
 
     See the parts factory interface: AuxEmulatorPartsFactory. Also see the Taint Analyzer for
     a complete solution based on this class.
    """





    def __init__(self, language: ghidra.program.model.lang.Language):
        """
        Create a new emulator
        @param language the language (processor model)
        """
        ...



    def addAccessBreakpoint(self, range: ghidra.program.model.address.AddressRange, kind: ghidra.pcode.emu.PcodeMachine.AccessKind) -> None: ...

    def addBreakpoint(self, address: ghidra.program.model.address.Address, sleighCondition: unicode) -> None: ...

    def clearAccessBreakpoints(self) -> None: ...

    def clearAllInjects(self) -> None: ...

    def clearInject(self, address: ghidra.program.model.address.Address) -> None: ...

    def compileSleigh(self, sourceName: unicode, source: unicode) -> ghidra.pcode.exec.PcodeProgram: ...

    def equals(self, __a0: object) -> bool: ...

    def getAllThreads(self) -> java.util.Collection: ...

    def getArithmetic(self) -> ghidra.pcode.exec.PcodeArithmetic: ...

    def getClass(self) -> java.lang.Class: ...

    def getLanguage(self) -> ghidra.app.plugin.processors.sleigh.SleighLanguage: ...

    def getSharedState(self) -> ghidra.pcode.exec.PcodeExecutorState: ...

    def getSoftwareInterruptMode(self) -> ghidra.pcode.emu.PcodeMachine.SwiMode: ...

    def getStubUseropLibrary(self) -> ghidra.pcode.exec.PcodeUseropLibrary: ...

    def getThread(self, name: unicode, createIfAbsent: bool) -> ghidra.pcode.emu.PcodeThread: ...

    def getUseropLibrary(self) -> ghidra.pcode.exec.PcodeUseropLibrary: ...

    def hashCode(self) -> int: ...

    def inject(self, address: ghidra.program.model.address.Address, source: unicode) -> None: ...

    def isSuspended(self) -> bool: ...

    @overload
    def newThread(self) -> ghidra.pcode.emu.PcodeThread: ...

    @overload
    def newThread(self, name: unicode) -> ghidra.pcode.emu.PcodeThread: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def setSoftwareInterruptMode(self, mode: ghidra.pcode.emu.PcodeMachine.SwiMode) -> None: ...

    def setSuspended(self, suspended: bool) -> None: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

