from typing import List
import ghidra.pcode.exec
import ghidra.program.model.lang
import ghidra.program.model.pcode
import java.lang
import java.util


class LocationPcodeArithmetic(java.lang.Enum, ghidra.pcode.exec.PcodeArithmetic):
    BIG_ENDIAN: ghidra.pcode.exec.LocationPcodeArithmetic = BIG_ENDIAN
    LITTLE_ENDIAN: ghidra.pcode.exec.LocationPcodeArithmetic = LITTLE_ENDIAN







    @overload
    def binaryOp(self, __a0: ghidra.program.model.pcode.PcodeOp, __a1: object, __a2: object) -> object: ...

    @overload
    def binaryOp(self, __a0: int, __a1: int, __a2: int, __a3: ghidra.pcode.exec.ValueLocation, __a4: int, __a5: ghidra.pcode.exec.ValueLocation) -> ghidra.pcode.exec.ValueLocation: ...

    @overload
    def binaryOp(self, __a0: int, __a1: int, __a2: int, __a3: object, __a4: int, __a5: object) -> object: ...

    @overload
    def compareTo(self, __a0: java.lang.Enum) -> int: ...

    @overload
    def compareTo(self, __a0: object) -> int: ...

    def describeConstable(self) -> java.util.Optional: ...

    def equals(self, __a0: object) -> bool: ...

    @staticmethod
    def forEndian(__a0: bool) -> ghidra.pcode.exec.LocationPcodeArithmetic: ...

    @overload
    def fromConst(self, __a0: List[int]) -> object: ...

    @overload
    def fromConst(self, __a0: long, __a1: int) -> ghidra.pcode.exec.ValueLocation: ...

    @overload
    def fromConst(self, __a0: long, __a1: int) -> ghidra.pcode.exec.ValueLocation: ...

    @overload
    def fromConst(self, __a0: long, __a1: int, __a2: bool) -> ghidra.pcode.exec.ValueLocation: ...

    def getClass(self) -> java.lang.Class: ...

    def getDeclaringClass(self) -> java.lang.Class: ...

    def getEndian(self) -> ghidra.program.model.lang.Endian: ...

    def hashCode(self) -> int: ...

    def isTrue(self, __a0: object, __a1: ghidra.pcode.exec.PcodeArithmetic.Purpose) -> bool: ...

    @overload
    def modAfterLoad(self, __a0: int, __a1: int, __a2: ghidra.pcode.exec.ValueLocation, __a3: int, __a4: ghidra.pcode.exec.ValueLocation) -> ghidra.pcode.exec.ValueLocation: ...

    @overload
    def modAfterLoad(self, __a0: int, __a1: int, __a2: object, __a3: int, __a4: object) -> object: ...

    @overload
    def modBeforeStore(self, __a0: int, __a1: int, __a2: ghidra.pcode.exec.ValueLocation, __a3: int, __a4: ghidra.pcode.exec.ValueLocation) -> ghidra.pcode.exec.ValueLocation: ...

    @overload
    def modBeforeStore(self, __a0: int, __a1: int, __a2: object, __a3: int, __a4: object) -> object: ...

    def name(self) -> unicode: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def ordinal(self) -> int: ...

    def ptrAdd(self, __a0: int, __a1: int, __a2: object, __a3: int, __a4: object, __a5: int) -> object: ...

    def ptrSub(self, __a0: int, __a1: int, __a2: object, __a3: int, __a4: object) -> object: ...

    @overload
    def sizeOf(self, __a0: ghidra.pcode.exec.ValueLocation) -> long: ...

    @overload
    def sizeOf(self, __a0: object) -> long: ...

    def sizeOfAbstract(self, __a0: object) -> object: ...

    def toBigInteger(self, __a0: object, __a1: ghidra.pcode.exec.PcodeArithmetic.Purpose) -> long: ...

    @overload
    def toConcrete(self, __a0: ghidra.pcode.exec.ValueLocation, __a1: ghidra.pcode.exec.PcodeArithmetic.Purpose) -> List[int]: ...

    @overload
    def toConcrete(self, __a0: object, __a1: ghidra.pcode.exec.PcodeArithmetic.Purpose) -> List[int]: ...

    def toLong(self, __a0: object, __a1: ghidra.pcode.exec.PcodeArithmetic.Purpose) -> long: ...

    def toString(self) -> unicode: ...

    @overload
    def unaryOp(self, __a0: ghidra.program.model.pcode.PcodeOp, __a1: object) -> object: ...

    @overload
    def unaryOp(self, __a0: int, __a1: int, __a2: int, __a3: ghidra.pcode.exec.ValueLocation) -> ghidra.pcode.exec.ValueLocation: ...

    @overload
    def unaryOp(self, __a0: int, __a1: int, __a2: int, __a3: object) -> object: ...

    @overload
    @staticmethod
    def valueOf(__a0: unicode) -> ghidra.pcode.exec.LocationPcodeArithmetic: ...

    @overload
    @staticmethod
    def valueOf(__a0: java.lang.Class, __a1: unicode) -> java.lang.Enum: ...

    @staticmethod
    def values() -> List[ghidra.pcode.exec.LocationPcodeArithmetic]: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def endian(self) -> ghidra.program.model.lang.Endian: ...