import ghidra.dbg.target.schema
import ghidra.program.model.address
import ghidra.trace.database.target
import ghidra.trace.model
import ghidra.trace.model.target
import ghidra.util
import ghidra.util.database
import ghidra.util.database.spatial
import java.lang


class DBTraceObjectValueData(ghidra.util.database.spatial.DBTreeDataRecord, ghidra.trace.database.target.InternalTraceObjectValue, ghidra.trace.database.target.ValueShape):




    def __init__(self, __a0: ghidra.trace.database.target.DBTraceObjectManager, __a1: ghidra.trace.database.target.DBTraceObjectValueRStarTree, __a2: ghidra.util.database.DBCachedObjectStore, __a3: db.DBRecord): ...



    def castValue(self) -> object: ...

    def delete(self) -> None: ...

    def description(self) -> unicode: ...

    def doDelete(self) -> None: ...

    def doDeleteAndEmit(self) -> None: ...

    def doSetLifespan(self, __a0: ghidra.trace.model.Lifespan) -> None: ...

    def doSetLifespanAndEmit(self, __a0: ghidra.trace.model.Lifespan) -> None: ...

    def doSetPrimitive(self, __a0: object) -> None: ...

    def doTruncateOrDelete(self, __a0: ghidra.trace.model.Lifespan) -> ghidra.trace.database.target.InternalTraceObjectValue: ...

    def doTruncateOrDeleteAndEmitLifeChange(self, __a0: ghidra.trace.model.Lifespan) -> ghidra.trace.database.target.InternalTraceObjectValue: ...

    def equals(self, __a0: object) -> bool: ...

    def getAddressSpaceId(self) -> int: ...

    def getBounds(self) -> ghidra.util.database.spatial.BoundingShape: ...

    def getCanonicalPath(self) -> ghidra.trace.model.target.TraceObjectKeyPath: ...

    def getChild(self) -> ghidra.trace.model.target.TraceObject: ...

    def getChildOrNull(self) -> ghidra.trace.database.target.DBTraceObject: ...

    def getClass(self) -> java.lang.Class: ...

    def getEntryKey(self) -> unicode: ...

    def getKey(self) -> long: ...

    def getLifespan(self) -> ghidra.trace.model.Lifespan: ...

    def getManager(self) -> ghidra.trace.database.target.DBTraceObjectManager: ...

    def getMaxAddress(self, __a0: ghidra.program.model.address.AddressFactory) -> ghidra.program.model.address.Address: ...

    def getMaxAddressOffset(self) -> long: ...

    def getMaxSnap(self) -> long: ...

    def getMinAddress(self, __a0: ghidra.program.model.address.AddressFactory) -> ghidra.program.model.address.Address: ...

    def getMinAddressOffset(self) -> long: ...

    def getMinSnap(self) -> long: ...

    def getObjectKey(self) -> ghidra.util.database.ObjectKey: ...

    def getParent(self) -> ghidra.trace.model.target.TraceObject: ...

    def getParentKey(self) -> long: ...

    def getRange(self, __a0: ghidra.program.model.address.AddressFactory) -> ghidra.program.model.address.AddressRange: ...

    def getShape(self) -> ghidra.util.database.spatial.BoundedShape: ...

    def getTableName(self) -> unicode: ...

    def getTargetSchema(self) -> ghidra.dbg.target.schema.TargetObjectSchema: ...

    def getTrace(self) -> ghidra.trace.model.Trace: ...

    def getValue(self) -> object: ...

    def hashCode(self) -> int: ...

    def isCanonical(self) -> bool: ...

    @overload
    def isDeleted(self) -> bool: ...

    @overload
    def isDeleted(self, __a0: ghidra.util.Lock) -> bool: ...

    def isHidden(self) -> bool: ...

    def isObject(self) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def setInvalid(self) -> None: ...

    @overload
    def setLifespan(self, __a0: ghidra.trace.model.Lifespan) -> None: ...

    @overload
    def setLifespan(self, __a0: ghidra.trace.model.Lifespan, __a1: ghidra.trace.model.target.TraceObject.ConflictResolution) -> None: ...

    def setMaxSnap(self, __a0: long) -> None: ...

    def setMinSnap(self, __a0: long) -> None: ...

    def setParentKey(self, __a0: long) -> None: ...

    @overload
    def setShape(self, __a0: ghidra.trace.database.target.ValueShape) -> None: ...

    @overload
    def setShape(self, __a0: ghidra.util.database.spatial.BoundedShape) -> None: ...

    def toString(self) -> unicode: ...

    def truncateOrDelete(self, __a0: ghidra.trace.model.Lifespan) -> ghidra.trace.model.target.TraceObjectValue: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def addressSpaceId(self) -> int: ...

    @property
    def bounds(self) -> ghidra.trace.database.target.ValueBox: ...

    @property
    def canonical(self) -> bool: ...

    @property
    def canonicalPath(self) -> ghidra.trace.model.target.TraceObjectKeyPath: ...

    @property
    def child(self) -> ghidra.trace.database.target.DBTraceObject: ...

    @property
    def childOrNull(self) -> ghidra.trace.database.target.DBTraceObject: ...

    @property
    def entryKey(self) -> unicode: ...

    @property
    def lifespan(self) -> ghidra.trace.model.Lifespan: ...

    @lifespan.setter
    def lifespan(self, value: ghidra.trace.model.Lifespan) -> None: ...

    @property
    def manager(self) -> ghidra.trace.database.target.DBTraceObjectManager: ...

    @property
    def maxAddressOffset(self) -> long: ...

    @property
    def maxSnap(self) -> long: ...

    @maxSnap.setter
    def maxSnap(self, value: long) -> None: ...

    @property
    def minAddressOffset(self) -> long: ...

    @property
    def minSnap(self) -> long: ...

    @minSnap.setter
    def minSnap(self, value: long) -> None: ...

    @property
    def object(self) -> bool: ...

    @property
    def parent(self) -> ghidra.trace.database.target.DBTraceObject: ...

    @property
    def parentKey(self) -> long: ...

    @parentKey.setter
    def parentKey(self, value: long) -> None: ...

    @property
    def shape(self) -> ghidra.trace.database.target.ValueShape: ...

    @shape.setter
    def shape(self, value: ghidra.trace.database.target.ValueShape) -> None: ...

    @property
    def trace(self) -> ghidra.trace.model.Trace: ...

    @property
    def value(self) -> object: ...