from typing import List
import db
import ghidra.program.model.address
import ghidra.util.database
import java.lang
import java.nio


class DBCachedObjectStoreFactory(object):





    class StringDBFieldCodec(ghidra.util.database.DBCachedObjectStoreFactory.AbstractDBFieldCodec):




        def __init__(self, __a0: java.lang.Class, __a1: java.lang.reflect.Field, __a2: int): ...



        def doLoad(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def doStore(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def encodeField(self, __a0: object) -> db.Field: ...

        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def getFieldType(self) -> java.lang.Class: ...

        def getObjectType(self) -> java.lang.Class: ...

        def getValue(self, __a0: ghidra.util.database.DBAnnotatedObject) -> object: ...

        def getValueType(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def load(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        @overload
        def store(self, __a0: unicode, __a1: db.StringField) -> None: ...

        @overload
        def store(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        @overload
        def store(self, __a0: object, __a1: db.Field) -> None: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...






    class EnumDBByteFieldCodec(ghidra.util.database.DBCachedObjectStoreFactory.AbstractDBFieldCodec):




        def __init__(self, __a0: java.lang.Class, __a1: java.lang.reflect.Field, __a2: int): ...



        def encodeField(self, __a0: object) -> db.Field: ...

        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def getFieldType(self) -> java.lang.Class: ...

        def getObjectType(self) -> java.lang.Class: ...

        def getValue(self, __a0: ghidra.util.database.DBAnnotatedObject) -> object: ...

        def getValueType(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def load(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        @overload
        def store(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        @overload
        def store(self, __a0: java.lang.Enum, __a1: db.ByteField) -> None: ...

        @overload
        def store(self, __a0: object, __a1: db.Field) -> None: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...






    class AbstractDBFieldCodec(object, ghidra.util.database.DBCachedObjectStoreFactory.DBFieldCodec):




        def __init__(self, __a0: java.lang.Class, __a1: java.lang.Class, __a2: java.lang.Class, __a3: java.lang.reflect.Field, __a4: int): ...



        def encodeField(self, __a0: object) -> db.Field: ...

        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def getFieldType(self) -> java.lang.Class: ...

        def getObjectType(self) -> java.lang.Class: ...

        def getValue(self, __a0: ghidra.util.database.DBAnnotatedObject) -> object: ...

        def getValueType(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def load(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        @overload
        def store(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        @overload
        def store(self, __a0: object, __a1: db.Field) -> None: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...

        @property
        def fieldType(self) -> java.lang.Class: ...

        @property
        def objectType(self) -> java.lang.Class: ...

        @property
        def valueType(self) -> java.lang.Class: ...




    class ByteDBFieldCodec(ghidra.util.database.DBCachedObjectStoreFactory.AbstractDBFieldCodec):




        def __init__(self, __a0: java.lang.Class, __a1: java.lang.reflect.Field, __a2: int): ...



        def doLoad(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def doStore(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def encodeField(self, __a0: object) -> db.Field: ...

        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def getFieldType(self) -> java.lang.Class: ...

        def getObjectType(self) -> java.lang.Class: ...

        def getValue(self, __a0: ghidra.util.database.DBAnnotatedObject) -> object: ...

        def getValueType(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def load(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        @overload
        def store(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        @overload
        def store(self, __a0: int, __a1: db.ByteField) -> None: ...

        @overload
        def store(self, __a0: object, __a1: db.Field) -> None: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...






    class RecAddress(java.lang.Record):




        def __init__(self, __a0: int, __a1: long): ...



        def equals(self, __a0: object) -> bool: ...

        @staticmethod
        def fromAddress(__a0: ghidra.program.model.address.Address) -> ghidra.util.database.DBCachedObjectStoreFactory.RecAddress: ...

        def getClass(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        def offset(self) -> long: ...

        def spaceId(self) -> int: ...

        def toAddress(self, __a0: ghidra.program.model.address.AddressFactory) -> ghidra.program.model.address.Address: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...






    class ShortDBFieldCodec(ghidra.util.database.DBCachedObjectStoreFactory.AbstractDBFieldCodec):




        def __init__(self, __a0: java.lang.Class, __a1: java.lang.reflect.Field, __a2: int): ...



        def doLoad(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def doStore(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def encodeField(self, __a0: object) -> db.Field: ...

        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def getFieldType(self) -> java.lang.Class: ...

        def getObjectType(self) -> java.lang.Class: ...

        def getValue(self, __a0: ghidra.util.database.DBAnnotatedObject) -> object: ...

        def getValueType(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def load(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        @overload
        def store(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        @overload
        def store(self, __a0: int, __a1: db.ShortField) -> None: ...

        @overload
        def store(self, __a0: object, __a1: db.Field) -> None: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...






    class ByteArrayDBFieldCodec(ghidra.util.database.DBCachedObjectStoreFactory.AbstractDBFieldCodec):




        def __init__(self, __a0: java.lang.Class, __a1: java.lang.reflect.Field, __a2: int): ...



        def doLoad(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def doStore(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def encodeField(self, __a0: object) -> db.Field: ...

        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def getFieldType(self) -> java.lang.Class: ...

        def getObjectType(self) -> java.lang.Class: ...

        def getValue(self, __a0: ghidra.util.database.DBAnnotatedObject) -> object: ...

        def getValueType(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def load(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        @overload
        def store(self, __a0: List[int], __a1: db.BinaryField) -> None: ...

        @overload
        def store(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        @overload
        def store(self, __a0: object, __a1: db.Field) -> None: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...






    class DBFieldCodec(object):








        def encodeField(self, __a0: object) -> db.Field: ...

        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def getFieldType(self) -> java.lang.Class: ...

        def getObjectType(self) -> java.lang.Class: ...

        def getValue(self, __a0: ghidra.util.database.DBAnnotatedObject) -> object: ...

        def getValueType(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def load(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        @overload
        def store(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        @overload
        def store(self, __a0: object, __a1: db.Field) -> None: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...

        @property
        def fieldType(self) -> java.lang.Class: ...

        @property
        def objectType(self) -> java.lang.Class: ...

        @property
        def valueType(self) -> java.lang.Class: ...




    class IntDBFieldCodec(ghidra.util.database.DBCachedObjectStoreFactory.AbstractDBFieldCodec):




        def __init__(self, __a0: java.lang.Class, __a1: java.lang.reflect.Field, __a2: int): ...



        def doLoad(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def doStore(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def encodeField(self, __a0: object) -> db.Field: ...

        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def getFieldType(self) -> java.lang.Class: ...

        def getObjectType(self) -> java.lang.Class: ...

        def getValue(self, __a0: ghidra.util.database.DBAnnotatedObject) -> object: ...

        def getValueType(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def load(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        @overload
        def store(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        @overload
        def store(self, __a0: int, __a1: db.IntField) -> None: ...

        @overload
        def store(self, __a0: object, __a1: db.Field) -> None: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...






    class VariantDBFieldCodec(ghidra.util.database.DBCachedObjectStoreFactory.AbstractDBFieldCodec):




        def __init__(self, __a0: java.lang.Class, __a1: java.lang.reflect.Field, __a2: int): ...



        def encodeField(self, __a0: object) -> db.Field: ...

        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def getFieldType(self) -> java.lang.Class: ...

        def getObjectType(self) -> java.lang.Class: ...

        def getValue(self, __a0: ghidra.util.database.DBAnnotatedObject) -> object: ...

        def getValueType(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def load(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        @overload
        def store(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        @overload
        def store(self, __a0: object, __a1: db.BinaryField) -> None: ...

        @overload
        def store(self, __a0: object, __a1: db.Field) -> None: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...






    class PrimitiveCodec(object):
        ADDRESS: ghidra.util.database.DBCachedObjectStoreFactory.PrimitiveCodec = ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$3@25cb5434
        BOOL: ghidra.util.database.DBCachedObjectStoreFactory.PrimitiveCodec = ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$SimplePrimitiveCodec@5ab71f47
        BOOL_ARR: ghidra.util.database.DBCachedObjectStoreFactory.PrimitiveCodec = ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$ArrayPrimitiveCodec@78d2aced
        BYTE: ghidra.util.database.DBCachedObjectStoreFactory.PrimitiveCodec = ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$SimplePrimitiveCodec@7288ff81
        BYTE_ARR: ghidra.util.database.DBCachedObjectStoreFactory.PrimitiveCodec = ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$2@7c57308a
        CHAR: ghidra.util.database.DBCachedObjectStoreFactory.PrimitiveCodec = ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$SimplePrimitiveCodec@2a28c5f0
        CHAR_ARR: ghidra.util.database.DBCachedObjectStoreFactory.PrimitiveCodec = ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$ArrayPrimitiveCodec@1b9ea4ce
        CODECS_BY_CLASS: java.util.Map = {<type 'java.lang.Integer'>: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$SimplePrimitiveCodec@553d5e75, <type '[Z'>: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$ArrayPrimitiveCodec@78d2aced, <type 'java.lang.Long'>: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$SimplePrimitiveCodec@17badb9f, <type 'ghidra.util.database.DBCachedObjectStoreFactory$RecAddress'>: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$3@25cb5434, <type 'java.lang.Boolean'>: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$SimplePrimitiveCodec@5ab71f47, <type '[J'>: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$ArrayPrimitiveCodec@651acdb2, <type 'java.lang.String'>: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$1@4ae49e92, <type 'java.lang.Short'>: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$SimplePrimitiveCodec@7bd18650, <type '[S'>: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$ArrayPrimitiveCodec@62f169c6, <type 'java.lang.Byte'>: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$SimplePrimitiveCodec@7288ff81, <type '[B'>: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$2@7c57308a, <type '[I'>: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$ArrayPrimitiveCodec@b64d242, <type '[C'>: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$ArrayPrimitiveCodec@1b9ea4ce, <type '[Ljava.lang.String;'>: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$ArrayObjectCodec@758878de, <type 'java.lang.Character'>: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$SimplePrimitiveCodec@2a28c5f0, <type 'ghidra.util.database.DBCachedObjectStoreFactory$RecRange'>: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$4@7e6be584}
        CODECS_BY_SELECTOR: java.util.Map = {0: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$SimplePrimitiveCodec@5ab71f47, 1: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$SimplePrimitiveCodec@7288ff81, 2: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$SimplePrimitiveCodec@2a28c5f0, 3: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$SimplePrimitiveCodec@7bd18650, 4: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$SimplePrimitiveCodec@553d5e75, 5: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$SimplePrimitiveCodec@17badb9f, 6: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$1@4ae49e92, 7: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$ArrayPrimitiveCodec@78d2aced, 8: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$2@7c57308a, 9: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$ArrayPrimitiveCodec@1b9ea4ce, 10: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$ArrayPrimitiveCodec@62f169c6, 11: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$ArrayPrimitiveCodec@b64d242, 12: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$ArrayPrimitiveCodec@651acdb2, 14: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$ArrayObjectCodec@758878de, 15: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$3@25cb5434, 16: ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$4@7e6be584}
        INT: ghidra.util.database.DBCachedObjectStoreFactory.PrimitiveCodec = ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$SimplePrimitiveCodec@553d5e75
        INT_ARR: ghidra.util.database.DBCachedObjectStoreFactory.PrimitiveCodec = ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$ArrayPrimitiveCodec@b64d242
        LONG: ghidra.util.database.DBCachedObjectStoreFactory.PrimitiveCodec = ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$SimplePrimitiveCodec@17badb9f
        LONG_ARR: ghidra.util.database.DBCachedObjectStoreFactory.PrimitiveCodec = ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$ArrayPrimitiveCodec@651acdb2
        RANGE: ghidra.util.database.DBCachedObjectStoreFactory.PrimitiveCodec = ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$4@7e6be584
        SHORT: ghidra.util.database.DBCachedObjectStoreFactory.PrimitiveCodec = ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$SimplePrimitiveCodec@7bd18650
        SHORT_ARR: ghidra.util.database.DBCachedObjectStoreFactory.PrimitiveCodec = ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$ArrayPrimitiveCodec@62f169c6
        STRING: ghidra.util.database.DBCachedObjectStoreFactory.PrimitiveCodec = ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$1@4ae49e92
        STRING_ARR: ghidra.util.database.DBCachedObjectStoreFactory.PrimitiveCodec = ghidra.util.database.DBCachedObjectStoreFactory$PrimitiveCodec$ArrayObjectCodec@758878de







        def decode(self, __a0: java.nio.ByteBuffer) -> object: ...

        def encode(self, __a0: java.nio.ByteBuffer, __a1: object) -> None: ...

        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        @overload
        @staticmethod
        def getCodec(__a0: int) -> ghidra.util.database.DBCachedObjectStoreFactory.PrimitiveCodec: ...

        @overload
        @staticmethod
        def getCodec(__a0: java.lang.Class) -> ghidra.util.database.DBCachedObjectStoreFactory.PrimitiveCodec: ...

        def getSelector(self) -> int: ...

        def getValueClass(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...

        @property
        def selector(self) -> int: ...

        @property
        def valueClass(self) -> java.lang.Class: ...




    class BooleanDBFieldCodec(ghidra.util.database.DBCachedObjectStoreFactory.AbstractDBFieldCodec):




        def __init__(self, __a0: java.lang.Class, __a1: java.lang.reflect.Field, __a2: int): ...



        def doLoad(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def doStore(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def encodeField(self, __a0: object) -> db.Field: ...

        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def getFieldType(self) -> java.lang.Class: ...

        def getObjectType(self) -> java.lang.Class: ...

        def getValue(self, __a0: ghidra.util.database.DBAnnotatedObject) -> object: ...

        def getValueType(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def load(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        @overload
        def store(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        @overload
        def store(self, __a0: bool, __a1: db.BooleanField) -> None: ...

        @overload
        def store(self, __a0: object, __a1: db.Field) -> None: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...






    class LongDBFieldCodec(ghidra.util.database.DBCachedObjectStoreFactory.AbstractDBFieldCodec):




        def __init__(self, __a0: java.lang.Class, __a1: java.lang.reflect.Field, __a2: int): ...



        def doLoad(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def doStore(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def encodeField(self, __a0: object) -> db.Field: ...

        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def getFieldType(self) -> java.lang.Class: ...

        def getObjectType(self) -> java.lang.Class: ...

        def getValue(self, __a0: ghidra.util.database.DBAnnotatedObject) -> object: ...

        def getValueType(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def load(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        @overload
        def store(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        @overload
        def store(self, __a0: long, __a1: db.LongField) -> None: ...

        @overload
        def store(self, __a0: object, __a1: db.Field) -> None: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...






    class LongArrayDBFieldCodec(ghidra.util.database.DBCachedObjectStoreFactory.AbstractDBFieldCodec):




        def __init__(self, __a0: java.lang.Class, __a1: java.lang.reflect.Field, __a2: int): ...



        def encodeField(self, __a0: object) -> db.Field: ...

        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def getFieldType(self) -> java.lang.Class: ...

        def getObjectType(self) -> java.lang.Class: ...

        def getValue(self, __a0: ghidra.util.database.DBAnnotatedObject) -> object: ...

        def getValueType(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def load(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        @overload
        def store(self, __a0: List[long], __a1: db.BinaryField) -> None: ...

        @overload
        def store(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        @overload
        def store(self, __a0: object, __a1: db.Field) -> None: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...






    class RecRange(java.lang.Record):




        def __init__(self, __a0: int, __a1: long, __a2: long): ...



        def equals(self, __a0: object) -> bool: ...

        @staticmethod
        def fromRange(__a0: ghidra.program.model.address.AddressRange) -> ghidra.util.database.DBCachedObjectStoreFactory.RecRange: ...

        def getClass(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def max(self) -> long: ...

        def min(self) -> long: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        def spaceId(self) -> int: ...

        def toRange(self, __a0: ghidra.program.model.address.AddressFactory) -> ghidra.program.model.address.AddressRange: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...



    def __init__(self, __a0: ghidra.util.database.DBCachedDomainObjectAdapter): ...



    def equals(self, __a0: object) -> bool: ...

    def getClass(self) -> java.lang.Class: ...

    def getOrCreateCachedStore(self, __a0: unicode, __a1: java.lang.Class, __a2: ghidra.util.database.DBAnnotatedObjectFactory, __a3: bool) -> ghidra.util.database.DBCachedObjectStore: ...

    def getOrCreateTable(self, __a0: unicode, __a1: java.lang.Class, __a2: bool) -> db.Table: ...

    def hashCode(self) -> int: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

